# HTML_Darstellung.pm
package HTML_Darstellung;

################################################################################
# Datei:
#
# Beschreibung:
#   
################################################################################
#  St. Wagner - stwagner@dorf.goe.net (c) 2002 - 2004
################################################################################

use strict;

require Exporter;
use vars qw(@ISA @EXPORT $VERSION);

@ISA = qw(Exporter);
@EXPORT = qw(
	     &url_encode

	     &add_headline_to_array

	     &dim2_array_escapeHTML
	     &array_escapeHTML

	     &form_table 
	     &form_table_array
	     &print_table_array
	     &print_table_array2
             &link_table &link_table_array

	     &startDocument &endDocument
	     );

$VERSION = 0.6;

################################################################################

use CGI;
use CGI qw(:standard);
use CGI::Carp 'fatalsToBrowser';

use Config_param;
use CGI_Parameter;
use Array;
use CGI_Parameter;

################################################################################
#
# ------------------------------------------------------------------------------
#
# fgt Spaltennamen zum loesungsarray hinzu und ersetzt gleichzeitig 
# diese, falls vorgegeben, durch passende beschreibung
# ------------------------------------------------------------------------------
sub add_headline_to_array {
    my %anfrage = @_;

    my @spaltennamen = @{$anfrage{'header'}};
    my $i = 0;
    my $tmp;

    for($i = @spaltennamen; $i>=0; $i--) {
	$tmp = $conf_spaltennamen{"$spaltennamen[$i]"};
	if($tmp) {
	  $spaltennamen[$i] = $tmp;  
	}
    }

    unshift(@{$anfrage{'array'}}, \@spaltennamen);


    return(%anfrage);
}
#
# ------------------------------------------------------------------------------
#
# ein zweidimensionales Array wird mit escapeHTML durchlaufen und
# zurueckgegeben
# Voraussetzung: array_escapeHTML
# ------------------------------------------------------------------------------
sub dim2_array_escapeHTML {
    my (@matrix) = @_;

    my $ref_zeile;
    foreach $ref_zeile (@matrix) {
        @$ref_zeile = &array_escapeHTML(@$ref_zeile);
    }

    return(@matrix);
}

#
# ------------------------------------------------------------------------------
#
# ein eindimensionales Array wird mit escapeHTML durchlaufen und
# zurueckgegeben
# voraussetzung: CGI- Modul
# ------------------------------------------------------------------------------
sub array_escapeHTML {
    my (@array) = @_;
    my $i = @array;
    $i--;

    for( ; $i > 0 ; $i--) {
        $array[$i] = &escapeHTML($array[$i]);
    }
    return(@array);
}

#
# ------------------------------------------------------------------------------
#
# Versieht ein eindimensionales Array mit html-tag zur Tabellendarstellung
# Array wird als html tabellenzeile getaged
#    $number        <  0 ohne Farbcodierung
#                   == 0 Kopfzeile- Farbcodierung nach $conf_header_bgcolor
#                 gerade  Farbcodierung nach $conf_header_gerade
#               ungerade  Farbcodierung nach $conf_header_ungerade
# ------------------------------------------------------------------------------
sub form_table {
    my ($number, @value) = @_;
    my $zeile;

    if($number < 0) {
        $zeile = "<tr class=\"$conf_tabellen_style{'class'}\">\n<td>"
            .join("</td>\n<td>", @value)."</td>\n</tr>\n";
    }
    elsif($number == 0) {
        $zeile = "<tr bgcolor=\"$conf_tabellen_style{'header_bgcolor'}\" "
	    ." class=\"$conf_tabellen_style{'class'}\">\n<th><b>"
            .join("</b></th>\n<th><b>", @value)."</b></th>\n</tr>\n";
    }
    elsif($number % 2 == 0) {
        $zeile = "<tr bgcolor=\"$conf_tabellen_style{'tr_bgcolor_gerade'}\" "
	    ." class=\"$conf_tabellen_style{'class'}\">\n<td>"
            .join("</td>\n<td>", @value)."</td>\n</tr>\n";
    }
    else {
        $zeile = "<tr bgcolor=\"$conf_tabellen_style{'tr_bgcolor_ungerade'}\" "
	    ." class=\"$conf_tabellen_style{'class'}\">\n<td>"
            .join("</td>\n<td>", @value)."</td>\n</tr>\n";
    }
    $zeile =~ s/<td><\/td>/<td>\&nbsp;<\/td>/og;
    return ($zeile);
}

#
# ------------------------------------------------------------------------------
#
# Erstellt aus einem zweidimensionalen Array eine html-Tabelle mit Zeilen
# Farbkodierung entsprechend form_table
# ------------------------------------------------------------------------------
sub form_table_array {
    my (@matrix) = @_;

    my $i=0;
    my $ref_zeile;

    foreach $ref_zeile (@matrix) {
        @$ref_zeile = &form_table($i, @$ref_zeile);
        $i++;
    }

    return (@matrix);
}

#
# ------------------------------------------------------------------------------
#
#  Ausgeben eines zweidimensionales Arrays auf stdout
# ------------------------------------------------------------------------------
sub print_table_array {
    my (@matrix) = @_;

    my $ref_zeile;
    my $spalte;

    my $i;
    my $j;

    print "<table border=\"$conf_tabellen_style{'border'}\""
	." cellspacing=\"$conf_tabellen_style{'cellspacing'}\""
	." class=\"$conf_tabellen_style{'class'}\">\n";

    foreach $ref_zeile (@matrix) {
        foreach $spalte (@$ref_zeile) {
                    print "$spalte";
        }
    }

#    for ($i=0; $i < @matrix; $i++) {
#	for ($j=0; $j < @$ref_zeile; $j++) {
#	    print "@{${$matrix[$i]}[$j]}";
#	}
#    }
    

    print "</table>\n";
}

#
# ------------------------------------------------------------------------------
#
#  Ausgeben eines zweidimensionales Arrays auf stdout
# ------------------------------------------------------------------------------
sub print_table_array2 {
    my (@matrix) = @_;

    my $ref_zeile;
    my $spalte;

    my $i;
    my $j;

    print "<table border=\"1\" "
	." cellspacing=\"$conf_tabellen_style{'cellspacing'}\""
	." class=\"$conf_tabellen_style{'class'}\""
	.">\n";

    foreach $ref_zeile (@matrix) {
        foreach $spalte (@$ref_zeile) {
                    print "$spalte";
        }
    }

#    for ($i=0; $i < @matrix; $i++) {
#	for ($j=0; $j < @$ref_zeile; $j++) {
#	    print "@{${$matrix[$i]}[$j]}";
#	}
#    }
    

    print "</table>\n";
}


#
# ------------------------------------------------------------------------------
#
# In ein eindimensionales Perl-Array wird an vorgebener Stelle ein Wert
# mit einem html-link Versehen und Array zurueckgeliefert
# Parameter:
#   $spalte     verlinkde Spalte fest (0..n)
#   $link       Wert der Spalte welcher als id an die url angefuegt wird
#   $href       url zum link
#   @value      array
# ------------------------------------------------------------------------------
sub link_table {
    my ($spalte, $link, $href, @value) = @_;

    unless($value[$spalte] eq '') {
       $value[$spalte] = "<a href=\"$href"
          .&url_encode($value[$link])."\">"
          .$value[$spalte]."</a>";
    }
    return (@value);
}

#
# ------------------------------------------------------------------------------
#
# Verlinken eines 2 Dimensionalen Arrays entsprechend der Funktion link_table
#   Funktion link_table muss vorhanden sein
# ------------------------------------------------------------------------------
sub link_table_array {
    my ($spalte, $link, $href, @matrix) = @_;

    my $i=0;
    my $j;
    my $ref_zeile;

    foreach $ref_zeile (@matrix) {
        if($i) {
            if($spalte < 0) {
                for($j=0; $j < @$ref_zeile; $j++) {
                    unless($j == $link) {
                        @$ref_zeile = &link_table($j, $link, $href, @$ref_zeile);
                    }
                }
                @$ref_zeile = &link_table($link, $link, $href, @$ref_zeile);
            }
            else {
                @$ref_zeile = &link_table($spalte, $link, $href, @$ref_zeile);
            }
        }
        $i++;
    }

    return (@matrix);
}

#
#
# ------------------------------------------------------------------------------
#
#  Bringt Paramter zur Uebertragung per URL auf Format
# ------------------------------------------------------------------------------
sub url_encode {
    my ($link) = @_;
    $link =~ s/(^a-z0-9_.!~*'() -])/sprintf "%%%02X", ord($1)/ei; #'
  $link =~ tr/ /+/;
  return $link;
}

################################################################################
sub startDocument {
    my ($script, $q, $title) = @_;

    print $q->header();
    
    if($cgi_param{'autoscroll'} eq 'on') {
#	print "<script>\n"
#	    ."function autoReload() {"
##	    ." params = \"?\"; \n"
##	    ." for(i=0, n=
#	
##	    ." var timeID = setTimeout(\"location.href= document.URL + params\", ";
#	    ." var timeID = setTimeout(\"location.reload()\", ";
#	print $cgi_param{'interval'}*1000;
#	print ") }\n"
#	    ." </script>\n";
    
#	print $q->start_html(-meta => {'author' => 'St. Wagner'},
#			     -lang => 'de_DE',
#			     -style => {'src' => "$conf_page_style{'style_sheet'}"},
#			     -title => "$title",
#			     -bgcolor => "$conf_page_style{'bgcolor'}",
##			     -meta => ({-http_equiv => 'REFRESH', 
##					       -content => "0;$script"}),
#			     -onLoad => 'autoReload()');

	print "<html xmlns=\"http://www.w3.org/1999/xhtml\" lang=\"de_DE\" xml:lang=\"de_DE\">\n"
	    ."<head><title>Logviewer</title>\n"
	    ."<meta http-equiv=\"refresh\" content=\"$cgi_param{'interval'};$script?".&param_to_url()."\"/>\n"
	    ."<link rel=\"stylesheet\" type=\"text/css\" href=\"$conf_page_style{'style_sheet'}\" />"
	    ."</head>\n"
	    ."<body onload=\"autoReload()\" bgcolor=\"$conf_page_style{'bgcolor'}\">\n";


    }
    else {
	print $q->start_html(-meta => {'author' => 'St. Wagner'},
			     -lang => 'de_DE',
			     -style => {'src' => "$conf_page_style{'style_sheet'}"},
			     -title => "$title",
			     -bgcolor => "$conf_page_style{'bgcolor'}");
    }
    
}

sub endDocument {
    my ($script) = @_;

    print "</body>\n</html>\n";
}


## 
# Rueckgabe muss sein ;-)
1;

